#!/usr/bin/env python
# -*- coding:utf-8 -*-
from enum import Enum

from ._calculator import _Integer, _Converter


class StorageUnit(Enum):
    BIT = _Integer(1)
    BYTE = _Integer(BIT * 8)
    KB = _Integer(BYTE * 1024)
    MB = _Integer(KB * 1024)
    GB = _Integer(MB * 1024)
    TB = _Integer(GB * 1024)
    PB = _Integer(TB * 1024)
    EB = _Integer(PB * 1024)
    ZB = _Integer(EB * 1024)
    YB = _Integer(ZB * 1024)
    BB = _Integer(YB * 1024)
    NB = _Integer(BB * 1024)
    DB = _Integer(NB * 1024)

    def of(self, num: int or float) -> '_Converter':
        converter = _Converter(num)
        setattr(converter, "_Converter__decimal", self.value)
        return converter


__all__ = ['StorageUnit']
