#!/usr/bin/env python
# -*- coding:utf-8 -*-
from enum import Enum

from simplebox.converter._calculator import _Integer, _Converter


class TimeUnit(Enum):
    PICO_SECOND = _Integer(1)
    NANO_SECOND = _Integer(PICO_SECOND * 1000)
    MICRO_SECOND = _Integer(NANO_SECOND * 1000)
    MILLI_SECOND = _Integer(MICRO_SECOND * 1000)
    SECOND = _Integer(MILLI_SECOND * 1000)
    MINUTE = _Integer(SECOND * 60)
    HOUR = _Integer(MINUTE * 60)
    DAY = _Integer(HOUR * 24)

    def of(self, num: int or float) -> '_Converter':
        converter = _Converter(num)
        setattr(converter, "_Converter__decimal", self.value)
        return converter


__all__ = ['TimeUnit']
