#!/usr/bin/env python
# -*- coding:utf-8 -*-
from typing import Type


def raise_exception(cause: Type[BaseException], msg: str):
    if issubclass(BaseException, cause):
        raise cause(msg)
    raise BasicException(msg)


class BasicException(Exception):
    def __init__(self, *args):
        self.args = args


class CallException(BasicException):
    def __init__(self, *args):
        super().__init__(args)


class TimeoutExpiredException(BasicException):
    def __init__(self, *args):
        super().__init__(args)


class HttpException(BasicException):
    def __init__(self, *args):
        super().__init__(args)
